package labsheet3;

import labsheet2.TopHashTags;
import labsheet2.TopHashTagsMap;
import labsheet2.TopHashTagsReduce;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapred.FileInputFormat;
import org.apache.hadoop.mapred.FileOutputFormat;
import org.apache.hadoop.mapred.JobClient;
import org.apache.hadoop.mapred.JobConf;
import org.apache.hadoop.mapred.RunningJob;
import org.apache.hadoop.mapred.TextInputFormat;
import org.apache.hadoop.mapred.TextOutputFormat;
import org.apache.hadoop.mapreduce.JobID;

/** 
 * Written by Dr. Richard McCreadie for the SICSA Summer School
 * on Big Data Information Visualisation.
 * 
 * Contact me if you want to use these for non-personal use.
 * richard.mccreadie@glasgow.ac.uk
 */
public class TweetClassification {

	public static void main(String[] args) throws Exception {
		
		JobConf conf = new JobConf(TopHashTags.class);
	    conf.setJobName("wordcount");
	    
	    conf.setOutputKeyClass(LongWritable.class);
	    conf.setOutputValueClass(Text.class);
	        
	    conf.setMapperClass(TweetClassificationMap.class);
	    conf.setReducerClass(TweetClassificationReduce.class);
	        
	    conf.setMapOutputKeyClass(LongWritable.class);
	    conf.setMapOutputValueClass(Text.class);
	    
	    conf.setInputFormat(TextInputFormat.class);
	    conf.setOutputFormat(TRECOutputFormat.class);
	        
	    for (String file : args[0].split(",")) {
	    	FileInputFormat.addInputPath(conf, new Path(file));
	    }
	    FileOutputFormat.setOutputPath(conf, new Path(args[1]));
	        
	    JobID jobId = null;
	    boolean ranOK = true;
	    try{
	            RunningJob rj = JobClient.runJob(conf);
	            jobId = rj.getID();
	    } catch (Exception e) { 
	            ranOK = false;
	    }
	 }
	
}
